Attribute VB_Name = "mSysTray"
Option Explicit

' Types / Enumerations
Public Type NOTIFYICONDATA
  cbSize As Long
  hwnd As Long
  uID As Long
  uFlags As Long
  uCallbackMessage As Long
  hIcon As Long
  szTip As String * 64
End Type

' Constants
Public Const GWL_USERDATA = (-21&)
Public Const GWL_WNDPROC = (-4&)
Public Const WM_USER = &H400&

Public Const TRAY_CALLBACK = (WM_USER + 101&)
Public Const NIM_ADD = &H0&
Public Const NIM_MODIFY = &H1&
Public Const NIM_DELETE = &H2&
Public Const NIF_MESSAGE = &H1&
Public Const NIF_ICON = &H2&
Public Const NIF_TIP = &H4&

Public Const WM_MOUSEMOVE = &H200&
Public Const WM_LBUTTONDOWN = &H201&
Public Const WM_LBUTTONUP = &H202&
Public Const WM_LBUTTONDBLCLK = &H203&
Public Const WM_MBUTTONDBLCLK = &H209
Public Const WM_MBUTTONDOWN = &H207
Public Const WM_MBUTTONUP = &H208
Public Const WM_RBUTTONDOWN = &H204&
Public Const WM_RBUTTONUP = &H205&
Public Const WM_RBUTTONDBLCLK = &H206&

' Variables
Public PrevWndProc As Long

' Declarations
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long

' This is the control subclassed window procedure
Public Function SubWndProc(ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
On Error Resume Next
  
  Dim SysTray As cSysTray
  Dim ClassAddr As Long
  
  Select Case MSG
    Case TRAY_CALLBACK ' Callback message received when user clicks on system tray
      
      ' Retrieve long pointer to class object, this was saved in the USERDATA
      ' of the window structure after the user control was subclassed
      ClassAddr = GetWindowLong(hwnd, GWL_USERDATA) ' Get pointer to object
      CopyMemory SysTray, ClassAddr, 4              ' Copy an unreferenced pointer to object into variable
      SysTray.SendEvent lParam, wParam              ' Send windows message\user event to control
      CopyMemory SysTray, 0&, 4                     ' Nullify object pointer
      
  End Select
  
  ' Forward all messages to previous window procedure (This must be done)
  SubWndProc = CallWindowProc(PrevWndProc, hwnd, MSG, wParam, lParam)
  
End Function
